package FullSmoke;

use Moose;
use FullSmoke::JobManager;
use Function::Parameters qw/:std :modifiers/;
use Module::Runtime qw/use_module is_module_name compose_module_name/;
use FullSmoke::Util::MooseHelpers;
use Syntax::Keyword::Try;
use Module::List qw/list_modules/;

has_str_arg controller => (
  required => 1,
  documentation => 'Which controller script to use: '.join(', ', map {s/FullSmoke::JobController:://r} keys list_modules('FullSmoke::JobController::', {list_modules=>1})->%*)
);

has _controller_obj => (
  is => 'ro',
#  isa => 'FullSmoke::JobController',
  default => method() {
    my $mod_name = compose_module_name('FullSmoke::JobController', $self->controller);
    
    if (is_module_name($mod_name)) {
      my $mod = use_module($mod_name);
      return $mod->new_with_options();
    } else {
      die "Not a valid module: ". $self->controller;
    }
  },
  lazy => 1,
);

has manager => (
  isa => 'FullSmoke::JobManager', 
  is => 'ro', 
  default => sub {
    FullSmoke::JobManager->new_with_options(

    )
  },
  lazy => 1
);

method run() {
  $self->_controller_obj();
}

1;
