package FullSmoke::JobController::Roles::AllCPAN;

use Moose;
use FullSmoke::JobController; # get the exports too
use FullSmoke::Util::CPANIndex qw/distinfo get_all_dists/;
use FullSmoke::Util::MooseHelpers;

with 'FullSmoke::JobController';

requires 'perl_name';

method BUILD(@args) {
  add_rolephase all_cpan_modules => (
    code => method() {
      my @jobs;
      
      for my $dist (get_all_dists()) {
        push @jobs, $self->make_job(
          CPANModule =>
            perl_name => $self->perl_name,
            dist_info($dist),
        );
      }
      return @jobs
    }
  );

}

#phase final => (
#  finalize => 1, # Run regardless of what happened
#  code => method() {
#    return make_job(
#      'CPANMCleanup'
#    )
#  },
#);